searchNodes=[{"doc":"Functions to decrease the rate of some process.A Backoff algorithm is commonly used to space out repeated retransmissions of the same block of data, avoiding congestion.This module provides a data structure, Backoff, that holds the state and the configuration of the backoff algorithm. Then, we can use function step/1 to get the time to wait for repeating a process and a new state of the backoff algorithm.Exampleiex&gt; backoff = Backoff.new(kind: :exp) #Backoff&lt;kind: exp, min: 200, max: 15000&gt; iex&gt; {200, next_backoff} = Backoff.step(backoff) iex&gt; {400, _next_backoff} = Backoff.step(next_backoff)","ref":"Backoff.html","title":"Backoff","type":"module"},{"doc":"Creates a new Backoff.Returns a new Backoff configured by options/0.","ref":"Backoff.html#new/1","title":"Backoff.new/1","type":"function"},{"doc":"Sets a Backoff to the initial state.Given a Backoff, sets its state back to the initial value. Note that for rand implementation this functions has no effect.","ref":"Backoff.html#reset/1","title":"Backoff.reset/1","type":"function"},{"doc":"Computes the current delay.Given a Backoff, returns the current delay time a next state of the current Backoff.","ref":"Backoff.html#step/1","title":"Backoff.step/1","type":"function"},{"doc":"The implementation used to provide the Backoff behaviour.There are different ways to provide Backoff behaviour:rand: on every step, the delay time is computed randomly between two values, min and max.exp: every step the delay is increased exponentially.rand_exp: a combination of the previous two.","ref":"Backoff.html#t:kind/0","title":"Backoff.kind/0","type":"type"},{"doc":"Available options to configure a Backoff.kind: the implementation to be used. Can be any of the available kind/0s. Defaults to rand_exp.min: the minimum value that can return a Backoff. Defaults to 200.max: the maximum value that can return a Backoff. Defaults to 15000.","ref":"Backoff.html#t:option/0","title":"Backoff.option/0","type":"type"},{"doc":"A list of option/0.","ref":"Backoff.html#t:options/0","title":"Backoff.options/0","type":"type"},{"doc":"A Backoff state.An opaque data structure that holds the state and the configuration of a Backoff algorithm. Can be created with new/0 or new/1.","ref":"Backoff.html#t:t/0","title":"Backoff.t/0","type":"opaque"},{"doc":"Adapter interface to the AMQP RPC pattern.Plug.AMQP provides an AMQP interface to Plug. When using Plug.AMQP you can write servers that answer requests sent through an AMQP broker, like RabbitMQ. The request response pattern is explained in detail here.UsageTo use Plug.AMQP, add it to your supervision tree. Assuming that your Plug module is named MyPlug:children = [ {Plug.AMQP, connection_options: &quot;amqp://my-rabbit:5672&quot;, plug: MyPlug} ] Supervisor.start_link(children, strategy: :one_for_one)Check option/0 and Plug.AMQP.ConsumerProducer.option/0 for more options.ExamplesThe following example is taken from the RabbitMQ RPC Tutorial but using Plug.AMQP.# The Server defmodule MyPlug do @behaviour Plug @impl true def init(_opts), do: nil @impl true def call(conn, _opts) do {:ok, body, conn} = Plug.Conn.read_body(conn) input = String.to_integer(body) output = fib(input) resp_body = to_string(output) Plug.Conn.send_resp(conn, 200, resp_body) end defp fib(0), do: 0 defp fib(1), do: 1 defp fib(n) when n &gt; 1, do: fib(n - 1) + fib(n - 2) end # Setting Up the RPC Request Queue {:ok, conn} = AMQP.Connection.open() {:ok, chan} = AMQP.Channel.open(conn) {:ok, _info} = AMQP.Queue.declare(chan, &quot;rpc_queue&quot;) # Starting the Server {:ok, _adapter} = Plug.AMQP.start_link(consumer_queue: &quot;rpc_queue&quot;, plug: MyPlug) # Setting the Client {:ok, %{queue: callback_queue}} = AMQP.Queue.declare(chan, &quot;&quot;, exclusive: true) {:ok, _ctag} = AMQP.Basic.consume(chan, callback_queue, nil, no_ack: true) # Sending a Request IO.puts(&quot;Sending a 30 as a request&quot;) AMQP.Basic.publish(chan, &quot;&quot;, &quot;rpc_queue&quot;, &quot;30&quot;, reply_to: callback_queue) # Waiting a Response receive do {:basic_deliver, response, _meta} -&gt; IO.puts(&quot;Got a \#{response} response&quot;) end","ref":"Plug.AMQP.html","title":"Plug.AMQP","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Plug.AMQP.html#child_spec/1","title":"Plug.AMQP.child_spec/1","type":"function"},{"doc":"A Plug.AMQP configuration option.Plug.AMQP supports any of Plug.AMQP.ConsumerProducer.option/0. Also, the plug option must be used to set the main plug of a server.","ref":"Plug.AMQP.html#t:option/0","title":"Plug.AMQP.option/0","type":"type"},{"doc":"A list of option/0s.","ref":"Plug.AMQP.html#t:options/0","title":"Plug.AMQP.options/0","type":"type"},{"doc":"Adapter for AMQP to Plug.ConnThis adapter partially implements the Plug.Conn.Adapter behaviour, with the following caveats:Plug.Conn.Adapter.send_file/6, Plug.Conn.Adapter.send_chunked/3 and Plug.Conn.Adapter.chunk/2 raise, because there is no such functionality in AMQP. Also Plug.Conn.Adapter.push/3 and Plug.Conn.Adapter.inform/3 are not supported.Plug.Conn.Adapter.read_req_body/2 ignores the options and always returns the whole message body.request_path is taken from the routing_key, by replacing dots with slashes and prepending a slash. This will play nice with existing plugs that expect url-like paths.method is &quot;POST&quot; by default. You can override this behaviour setting a custom method in the x-method-override header.","ref":"Plug.AMQP.Conn.html","title":"Plug.AMQP.Conn","type":"module"},{"doc":"","ref":"Plug.AMQP.Conn.html#conn/3","title":"Plug.AMQP.Conn.conn/3","type":"function"},{"doc":"A consumer-producer for RPC over AMQP protocol.This module provides a consumer-producer for managing remote procedure calls over AMQP. A consumer-producer creates at least one connection to an AMQP broker. Request are received by consuming from the given queue. Responses are routed based on the reply_to message header.The response properties mirrors the properties of the request. For example, if a request is sent using persistence, the response will be sent using persistence too.UsageTo use this consumer-producer we must provide a request_handler/0 function. The consumer-producer will call this function to manage requests. Handlers can use send_resp/3 to return a response of the request producer (client). Check options/0 to get more info about all the options available.ExampleNote that we avoid creating a response queue here using the RabbitMQ Direct Reply-To extension.# Setting Up A Client {:ok, conn} = AMQP.Connection.open() {:ok, chan} = AMQP.Channel.open(conn) {:ok, _info} = AMQP.Queue.declare(chan, &quot;plug_amqp.consumer_producer.requests&quot;) {:ok, _ctag} = AMQP.Basic.consume(chan, &quot;amq.rabbitmq.reply-to&quot;, nil, no_ack: true) # Setting Up Consumer-Producer Server {:ok, _server} = Plug.AMQP.ConsumerProducer.start_link( consumer_queue: &quot;plug_amqp.consumer_producer.requests&quot;, request_handler: fn server, request, _headers -&gt; number = String.to_integer(request) Plug.AMQP.ConsumerProducer.send_resp(server, to_string(number + 1)) :ok end ) # Sending A Request IO.puts(&quot;Sending a request with payload \\&quot;1\\&quot;&quot;) AMQP.Basic.publish(chan, &quot;&quot;, &quot;plug_amqp.consumer_producer.requests&quot;, &quot;1&quot;, reply_to: &quot;amq.rabbitmq.reply-to&quot; ) # Receiving A Response receive do {:basic_deliver, response, _meta} -&gt; IO.puts(&quot;Received a response with payload \\&quot;\#{response}\\&quot;&quot;) end","ref":"Plug.AMQP.ConsumerProducer.html","title":"Plug.AMQP.ConsumerProducer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Plug.AMQP.ConsumerProducer.html#child_spec/1","title":"Plug.AMQP.ConsumerProducer.child_spec/1","type":"function"},{"doc":"Sends a response from a request handler","ref":"Plug.AMQP.ConsumerProducer.html#send_resp/3","title":"Plug.AMQP.ConsumerProducer.send_resp/3","type":"function"},{"doc":"Starts a new AMQP consumer-producer.","ref":"Plug.AMQP.ConsumerProducer.html#start_link/1","title":"Plug.AMQP.ConsumerProducer.start_link/1","type":"function"},{"doc":"A header of a request or a response","ref":"Plug.AMQP.ConsumerProducer.html#t:header/0","title":"Plug.AMQP.ConsumerProducer.header/0","type":"type"},{"doc":"A list of headers","ref":"Plug.AMQP.ConsumerProducer.html#t:headers/0","title":"Plug.AMQP.ConsumerProducer.headers/0","type":"type"},{"doc":"A set of options available to configure the AMQP Consumer-Producer.Note that consumer_queue option is required.backoff: how the backoff delay should behave. More info at Backoff.options/0.connection_name: the name of the connections created by the AMQP Consumer-Producer. Note that the Consumer-Producer can create several connections. In that case, the provided connection name will be used as a prefix.connection_options: configures the broker connection. All available options are available at AMQP.Connection.open/2.consumer_qos_options: configures the consumer QoS options. More info at AMQP.Basic.qos/2. global option does not apply in this context.consumer_queue: the name of the queue for consuming requests. Required.request_handler: the function of the type request_handler/0 that will handle request received by the Consumer-Producer.request_handler_supervisor: an instance of a Task.Supervisor to supervise handlers. The Consumer-Producer will use this supervisor to run request handlers, managing any kind of error, raise or exit produced by the handler.","ref":"Plug.AMQP.ConsumerProducer.html#t:option/0","title":"Plug.AMQP.ConsumerProducer.option/0","type":"type"},{"doc":"A list of option/0s.","ref":"Plug.AMQP.ConsumerProducer.html#t:options/0","title":"Plug.AMQP.ConsumerProducer.options/0","type":"type"},{"doc":"The payload of a request or a response.","ref":"Plug.AMQP.ConsumerProducer.html#t:payload/0","title":"Plug.AMQP.ConsumerProducer.payload/0","type":"type"},{"doc":"A handler for managing requests.","ref":"Plug.AMQP.ConsumerProducer.html#t:request_handler/0","title":"Plug.AMQP.ConsumerProducer.request_handler/0","type":"type"},{"doc":"A response of a request.","ref":"Plug.AMQP.ConsumerProducer.html#t:response/0","title":"Plug.AMQP.ConsumerProducer.response/0","type":"type"},{"doc":"","ref":"Plug.AMQP.UnsupportedError.html","title":"Plug.AMQP.UnsupportedError","type":"exception"},{"doc":"PlugAmqp Plug.AMQP provides an AMQP interface to Plug. When using Plug.AMQP we can write servers that answer requests sent through an AMQP broker, like RabbitMQ. The request response pattern is explained in detail here.Online documentation.","ref":"readme.html","title":"PlugAmqp","type":"extras"},{"doc":"We can use plug_amqp in our projects by adding the dependency:def deps do [ {:plug_amqp, &quot;~&gt; 0.5&quot;}, ] end","ref":"readme.html#installation","title":"PlugAmqp - Installation","type":"extras"},{"doc":"To use Plug.AMQP, add it to the supervision tree:children = [ {Plug.AMQP, connection_options: &quot;amqp://my-rabbit:5672&quot;, plug: MyPlug} ] Supervisor.start_link(children, strategy: :one_for_one)Here it is a Plug as an example:defmodule MyPlug do @behaviour Plug @impl true def init(_opts), do: nil @impl true def call(conn, _opts) do {:ok, body, conn} = Plug.Conn.read_body(conn) input = String.to_integer(body) output = fib(input) resp_body = to_string(output) Plug.Conn.send_resp(conn, 200, resp_body) end defp fib(0), do: 0 defp fib(1), do: 1 defp fib(n) when n &gt; 1, do: fib(n - 1) + fib(n - 2) endThen we can start sending messages to the server through AMQP:# Setting Up the RPC Request Queue {:ok, conn} = AMQP.Connection.open() {:ok, chan} = AMQP.Channel.open(conn) {:ok, _info} = AMQP.Queue.declare(chan, &quot;rpc_queue&quot;) # Starting the Server {:ok, _adapter} = Plug.AMQP.start_link(consumer_queue: &quot;rpc_queue&quot;, plug: MyPlug) # Setting the Client {:ok, %{queue: callback_queue}} = AMQP.Queue.declare(chan, &quot;&quot;, exclusive: true) {:ok, _ctag} = AMQP.Basic.consume(chan, callback_queue, nil, no_ack: true) # Sending a Request IO.puts(&quot;Sending a 30 as a request&quot;) AMQP.Basic.publish(chan, &quot;&quot;, &quot;rpc_queue&quot;, &quot;30&quot;, reply_to: callback_queue) # Waiting a Response receive do {:basic_deliver, response, _meta} -&gt; IO.puts(&quot;Got a \#{response} response&quot;) endCheck Plug.AMQP module from the online documentation for more information. Also, take a look the examples in the examples folder.","ref":"readme.html#usage","title":"PlugAmqp - Usage","type":"extras"}]